Austin Group Defect Tracker

Aardvark Mark III


Viewing Issue Simple Details Jump to Notes ] Issue History ] Print ]
ID Category Severity Type Date Submitted Last Update
0000333 [1003.1(2008)/Issue 7] Shell and Utilities Objection Enhancement Request 2010-10-13 04:39 2010-12-16 17:14
Reporter dwheeler View Status public  
Assigned To ajosey
Priority normal Resolution Accepted As Marked  
Status Resolved  
Name David A. Wheeler
Organization
User Reference
Section make
Page Number 2912
Line Number 95668
Interp Status ---
Final Accepted Text See Note: 0000593
Summary 0000333: Add support for silent includes using "-include"
Description The current specification for make permits "include", but does not have a "silent include" that ignores errors files do not exist. This is a disaster for automatically generating dependencies; a makefile could say "include DEPEND", but if DEPEND does not exist, the include fails, and thus any run using the makefile fails. But if the makefile is supposed to create DEPEND, we are unable to create DEPEND in the first place. For examples where this is important, see:
http://www.xs4all.nl/~evbergen/nonrecursive-make.html [^]

GNU make supports both "-include" and "sinclude" for this purpose (see http://www.gnu.org/software/automake/manual/make/Include.html). [^]
According to this message:
 http://marc.info/?l=freebsd-standards&m=118891505208650 [^]
NetBSD has added it, and FreeBSD has a patch available to support it.

This proposal suggests adding just "-include", but supporting "sinclude" (as well) would be fine. This already exists in implementations, we just need to get it into the standard itself.
Desired Action Line 95668:
After "If the word include"
append "(optionally prefixed with '-')"


Line 95686: At the end, append:
"If the file(s) do not exist, and the word include was prefixed with '-', the
include command is ignored.
"If the file(s) do not exist, and the word include was not prefixed with '-', the processing ends in failure."
Tags issue8
Attached Files

- Relationships

-  Notes
(0000593)
nick (manager)
2010-10-28 16:43

Proposed new wording:

At line 95668, change:
  If the word include appears at the beginning of a line
to
  If the word include (optionally prefixed with a <hyphen> character) appears at the beginning of a line

At line 95863, add the following:

"If the file cannot be opened, and if the word include was prefixed with a <hyphen> character, the file shall be ignored. Otherwise, if the file cannot be opened an error occurs."

- Issue History
Date Modified Username Field Change
2010-10-13 04:39 dwheeler New Issue
2010-10-13 04:39 dwheeler Status New => Under Review
2010-10-13 04:39 dwheeler Assigned To => ajosey
2010-10-13 04:39 dwheeler Name => David A. Wheeler
2010-10-13 04:39 dwheeler Section => make
2010-10-13 04:39 dwheeler Page Number => 2912
2010-10-13 04:39 dwheeler Line Number => 95668
2010-10-28 16:43 nick Note Added: 0000593
2010-12-16 17:14 Don Cragun Interp Status => ---
2010-12-16 17:14 Don Cragun Final Accepted Text => See Note: 0000593
2010-12-16 17:14 Don Cragun Status Under Review => Resolved
2010-12-16 17:14 Don Cragun Resolution Open => Accepted As Marked
2010-12-16 17:14 Don Cragun Tag Attached: issue8
2011-12-07 23:25 dwheeler Issue Monitored: dwheeler


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker